## ros-melodic-toposens-sensor-library 1.2.4

=== toposens-library/CMakeLists.txt ===
##
## Copyright (c) Toposens GmbH 2022. All rights reserved.
##

cmake_minimum_required(VERSION 3.10)

# The project
project(toposens-library)

# Add the sub-directories
add_subdirectory(toposens_sensor_library)
add_subdirectory(examples)
