=== external/iso-tp/CMakeLists.txt ===
##
## Copyright (c) Toposens GmbH 2022. All rights reserved.
##

cmake_minimum_required(VERSION 3.16.0)

project(toposens-iso-tp C)

add_library(${PROJECT_NAME}
  STATIC
    topo_isotp.c
    isotp.c
)

target_include_directories(${PROJECT_NAME}
    PUBLIC
      .
)

target_link_libraries(${PROJECT_NAME} PRIVATE toposens-core-libs )
