=== external/nanopb/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)


project(nanopb LANGUAGES C)

add_library(${PROJECT_NAME}
  INTERFACE
)

target_include_directories(${PROJECT_NAME}
  INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_sources(${PROJECT_NAME}
    INTERFACE
        pb_encode.c
        pb_decode.c
        pb_common.c
)
