=== debian/changelog ===
ros-melodic-toposens-sensor-library (1.2.4-4bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Thomas Böhm <boehm@toposens.com>  Tue, 17 May 2022 15:43:50 -0000
