=== debian/control ===
Source: ros-melodic-toposens-sensor-library
Section: misc
Priority: optional
Maintainer: Thomas Böhm <boehm@toposens.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev
Homepage: https://toposens.com
Standards-Version: 3.9.2

Package: ros-melodic-toposens-sensor-library
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-melodic-catkin
Description: Driver for toposens echo sensor
